<id>
More Board and Catagory Options 2.0 - Denied Access Addon
</id>

<version>
1.0 beta
</version>

<mod info>
This mod was written as an addon for the "More Board and Catagory Options" mod (version 2.0) - If you do not have that mod installed, do not install this addon!

With the standard MBCO2 mod, you can use the options provided to define which membergroups/users are allowed to start topics, post replies, and view topics for each board of your forum.
Once you have installed this addon, you will be able to use these same options to exclude membergroups/users from these actions by placing an exclaimation mark (!) in front of the membergroup or username.
</mod info>

<author>
BHRA Webmaster
</author>

<homepage>
http://www.bhra.org.uk
</homepage>

<edit file>
Sources/Security.pl
</edit file>

<search for>
	my $access = "denied";
</search for>

<replace>
	my $tmpa = 0;
	my $tmpb = 0;
	my $access = "denied";
</replace>

<search for>
	unless ($access eq "granted") {
 		foreach $user (@allowed_users) {
			chomp $user;
  			if ($user eq $username) {$access = "granted"; last;}  
 		} 
	}
	unless ($access eq "granted") {
 		foreach $element (@allowed_groups) {
			chomp $element;
			if ($element eq "all") {$access = "granted"; last;} 
			if ($element eq "members" && $username ne "Guest"){$access = "granted"; last;}
			if ($element eq $memberinfo) {$access = "granted"; last;} 
			if ($element eq "moderator" && ($memsettings[7] eq 'Administrator' || $memsettings[7] eq 'Global Moderator' || exists $moderators{$username})) {$access = "granted"; last;}
		}
	}
</search for>

<replace>
 	foreach $element (@allowed_users) { if (substr($element,0,1) ne "!") {$tmpa = 1;} else {$tmpb = 1;} }
 	foreach $element (@allowed_groups) { if (substr($element,0,1) ne "!") {$tmpa = 1;} else {$tmpb = 1;} }
	if (!$tmpa && $tmpb) {$access = "granted";}	# only excluded groups listed - default to access granted

 	foreach $element (@allowed_groups) {
		chomp $element;
		if ($element eq "all") {$access = "granted";} 
		if ($element eq "members" && $username ne "Guest"){$access = "granted";}
		if ($element eq $memberinfo) {$access = "granted";} 
		if ($element eq "!".$memberinfo) {$access = "denied";} 
		if ($element eq "moderator" && ($memsettings[7] eq 'Administrator' || $memsettings[7] eq 'Global Moderator' || exists $moderators{$username})) {$access = "granted";}
	}
 	foreach $user (@allowed_users) {
		chomp $user;
  		if ($user eq $username) {$access = "granted"; last;}  
  		if ($user eq "!".$username) {$access = "denied"; last;}  
 	} 
</replace>